unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SHDocVw, ExtCtrls, MSXML2_TLB, ComCtrls;

type
  TFMMain = class(TForm)
    Panel1: TPanel;
    ButtonRunQuery: TButton;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label2: TLabel;
    WebBrowserXMLData: TWebBrowser;
    Label3: TLabel;
    WebBrowserQueryResult: TWebBrowser;
    GroupBox1: TGroupBox;
    EditQueryPattern: TEdit;
    RadioButtonAutobiographies: TRadioButton;
    RadioButtonPhilosophy: TRadioButton;
    RadioButtonLessThan10Dollars: TRadioButton;
    RadioButtonCustomSearch: TRadioButton;
    procedure ButtonRunQueryClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function QueryPattern: String;
  public
    XmlDoc: IXMLDOMDocument;
    StringCollection: TStringList;
  end;

var
  FMMain: TFMMain;

implementation

uses DisplayXML;

{$R *.DFM}

function TFMMain.QueryPattern: String;
begin
  Result := '';
  if RadioButtonAutobiographies.Checked then
    Result := '/bookstore/book[@genre="autobiography"]'
  else if RadioButtonPhilosophy.Checked then
    Result := '/bookstore/book[@genre="philosophy"]'
  else if RadioButtonLessThan10Dollars.Checked then
    Result := '/bookstore/book [price $lt$ 9]'
  else
    Result := EditQueryPattern.Text;
end;

procedure TFMMain.ButtonRunQueryClick(Sender: TObject);
var
  Flags: OLEVariant;
  NodeList: IXMLDOMNodeList;
begin
  NodeList := XmlDoc.documentElement.selectNodes(QueryPattern);
  StringCollection.Clear;
  HTMLforNodeList(StringCollection, NodeList);
  StringCollection.SaveToFile('c:\temp.htm');
  Flags := 0;
  WebBrowserQueryResult.Navigate(WideString('c:/temp.htm'), Flags, Flags, Flags, Flags);
end;

procedure TFMMain.FormCreate(Sender: TObject);
var
  Flags: OLEVariant;
begin
  XmlDoc := CoDOMDocument.Create;
  XmlDoc.async := False;
  XmlDoc.load('sample.xml');

  StringCollection := TStringList.Create;
  HTMLforNode(StringCollection, XmlDoc.documentElement);
  StringCollection.SaveToFile('c:\temp.htm');
  Flags := 0;
  WebBrowserXMLData.Navigate(WideString('c:/temp.htm'), Flags, Flags, Flags, Flags);
end;

procedure TFMMain.FormDestroy(Sender: TObject);
begin
  XmlDoc := nil;
  StringCollection.Free;
end;

end.
